function gui_set_userdata(handle_in,varargin)
%
% Sets properties in userdata
%
% handle_in:  vector of handles or structure of handles
%
% properties can be given as
%  1) list of properties and values
%     'prop1',val1,'prop2',val2, .....
%  2) structure of properties and values
%     struct( 'prop1',val1,'prop2',val2, .....)
% 
% Author:  Winfried Kernbichler
% Version: 1.0 
% Date:    October 17, 2001
% Status:  Workes very well in all tests at the moment
% Missing: Check of input

% convert structur to vector for easy use
if isstruct(handle_in)
  hin = gui_handle_convert(handle_in);
else
  hin = handle_in;
end

% create cells of properrties and values
if length(varargin)==1 & isstruct(varargin{1})
  S = varargin{1};
  prop  = fieldnames(S);
  value = struct2cell(S); 
else
  props = varargin(1:2:end);
  value = varargin(2:2:end);
end

for l = 1:length(hin) % cycle through handles
  USER = get(hin(l),'userdata');

  for k = 1:length(props) % cycle through properties
    prop = props{k};
    val  = value{k};
    if ~iscell(val)
      e_str = ['USER.',prop,'=','val',';'];
    else
      if length(val)==1
	e_str = ['USER.',prop,'=','val{1}',';'];
      else
	e_str = ['USER.',prop,'=','val{l}',';'];
      end
    end    
    eval(e_str);
    set(hin(l),'userdata',USER);
  end
end






